Subject: [bug#63618] [PATCH WIP] Socat tests

From: Bruno Victal <[email-masked]>
Date: Sat, 20 May 2023 22:50:19 +0100

I've noticed that socat does have a test-suite (under a "test" target)
though I am having some trouble with some of the tests failures.

Going through the build log, there's some lines of interest:

Test 59:
--8<---------------cut here---------------start------------->8---
…
test  59 CHILDDEFAULT: child process default properties... FAILED:
 ./socat -t 0.1  -u exec:./procan -
…
--8<---------------cut here---------------end--------------->8---

In test 227, tests fail due to an absent /etc/services.
--8<---------------cut here---------------start------------->8---
…
test 227 EXECPTYKILL: exec:...,pty explicitely kills sub process... OK
grep: /etc/services: No such file or directory
test 228 TCP4SERVICE: echo via connection to TCP V4 socket... !port 1 timed out! FAILED:  ./socat:
 ./socat -t 0.1  TCP4-LISTEN:,reuseaddr PIPE &
2023/05/20 20:48:44 socat[8835] E empty port/service
 ./socat -t 0.1  stdin!!stdout TCP4:127.0.0.1:
2023/05/20 20:48:49 socat[8857] E empty port/service
test 229 EXCEED_FOPEN_MAX: more than FOPEN_MAX FDs in use... OK
…
--8<---------------cut here---------------end--------------->8---
Note: a similar failure was already observed in
d6f6b57766e95d2fa8af63d4460a2b303ca4d867.

I wonder if it's feasible to include /etc/services
in the build environment?

Test 418:
--8<---------------cut here---------------start------------->8---
…
test 418 ABSTRACT_USER: Is the fs related user option on ABSTRACT socket applied to FD... FAILED                                                                                                                                   
 ./socat ABSTRACT-LISTEN:temp,accept-timeout=0.1,user= FILE:/dev/null                                                                                                                                                              
2023/05/20 20:50:55 socat[12189] E getpwnam(""): no such user
…
--8<---------------cut here---------------end--------------->8---

I'm out of clues as to how to get these 3 tests sorted out.
Any ideas?

I've attached the build logs for socat with the tests enabled below.

Regards,
Bruno